'
'MADMIX GAME VER 1.2 MODIFIED 09/23/00
'
'BY ENRIQUE HUERTA MEZQUITA
'
'FEEL FREE TO CONTACT ME AT ENRIQUEMAIL@MIXMAIL.COM
'
'THIS PROGRAM IS FREE AND YOU ARE WELCOME TO USE ITS CODE IN YOUR
'OWN AS LONG AS YOU CREDIT ENRIQUE HUERTA MEZQUITA AS THE CONTRIBUTER.
'
'FOR MORE FUN VISIT MY OWN PAGE HTTP://WWW11.BRINKSTER.COM/FREESOURCE
'
'THE DEFAULT KEYS CANNOT BE CHANGED AND THESE ARE:
'
'       PLAYER CONTROL          OTHER
'       LEFT:  4                F8:    EXIT
'       RIGHT: 6                ESC:   CANCEL
'       UP:    8                ENTER: ACCEPT
'       DOWN:  2
'

DECLARE SUB LoadPcx (txt$)                      'loads PCX image
DECLARE SUB CheckRecord ()                      'inserts new record
DECLARE SUB LoadRecords ()                      'loads records
DECLARE SUB BlankScreen ()                      'clears the screen and draws a square
DECLARE SUB GameOver ()                         'prints 'game over'
DECLARE SUB LoadMap (file$)                     'loads map from disk
DECLARE SUB NextStage ()                        'prints stage name
DECLARE SUB RandomMove ()                       'phantom moves randomly
DECLARE SUB Ready ()                            'waits until hit any key
DECLARE SUB HaveLunch ()                        'pac eats
DECLARE SUB ViewText (X, Y, txt$)               'prints text
DECLARE SUB ViewWavyText (Y, txt$)              'prints wavy text
DECLARE SUB ViewPoints ()                       'prints player points
DECLARE SUB Wall ()                             'pac wall collision
DECLARE SUB MoveScreen ()                       'moves tile screen
DECLARE SUB AI ()                               'phantoms artificial intelligence
DECLARE SUB ViewWindow (fromx, fromy, tox, toy) 'prints a window
DECLARE FUNCTION Find ()                        'pac path finder
DECLARE FUNCTION ChooseFactor ()                'choose between bug and phantom loop
DECLARE FUNCTION Choice! ()                     'choose one option from the menu
DECLARE FUNCTION FileBrowser$ (txt$, txtmax)    'opens customize file
DECLARE FUNCTION Alert$ (txt$)                  'shows any alert

ON ERROR GOTO errortrapping

'defines map and tile dimensions
CONST memph = 20                                'maximum number of phantoms
DIM SHARED map(34, 30) AS INTEGER, tiles(50, 65), door(50, 12)
DIM SHARED boxes(8, 9)
DIM SHARED font(8, 53), chrcodes(256) AS INTEGER
DIM SHARED mouth(8, 3, 3, 3) AS INTEGER, sheet(8, 3, 3, 3) AS INTEGER, ass(8, 3, 3) AS INTEGER
DIM SHARED corners(3, 3, 4) AS INTEGER, dinner(3, 3, 2) AS INTEGER
DIM SHARED pacdeath(25) AS INTEGER, phantomdeath(14) AS INTEGER
DIM SHARED Abefore AS INTEGER, Bbefore AS INTEGER
DIM SHARED tryadda AS INTEGER, tryaddb  AS INTEGER
DIM SHARED A AS INTEGER, B  AS INTEGER
DIM SHARED adda AS INTEGER, addb  AS INTEGER
DIM SHARED doadda AS INTEGER, doaddb AS INTEGER, dopath AS INTEGER
DIM SHARED ghosta(memph) AS INTEGER, ghostb(memph) AS INTEGER
DIM SHARED addgha(memph) AS INTEGER, addghb(memph)  AS INTEGER
DIM SHARED pathsa(4) AS INTEGER, pathsb(4)  AS INTEGER
DIM SHARED points AS INTEGER, realpoints AS INTEGER, foodleft AS INTEGER, lives AS INTEGER
DIM SHARED name$, hallnames$(6), hallpoints(6) AS INTEGER
DIM SHARED accuracy AS INTEGER
DIM SHARED phantoms AS INTEGER, bugs AS INTEGER
DIM SHARED flip AS INTEGER, factor AS INTEGER
DIM SHARED character AS INTEGER, timeleft AS INTEGER
DIM SHARED rewind(memph) AS INTEGER, kickrewind(memph) AS INTEGER
DIM SHARED xx(170) AS INTEGER, yy(170) AS INTEGER, angle(170) AS INTEGER
DIM SHARED font$(50), C(94) AS INTEGER
DIM SHARED chosen AS INTEGER
DIM SHARED i AS INTEGER
DIM SHARED phantom(54, 16), bug(48, 4), pac(54, 24)
DIM SHARED dooropening AS INTEGER, xopening AS INTEGER, yopening AS INTEGER
DIM SHARED stagename$, stagetext$
DIM SHARED addlife AS INTEGER
DIM SHARED xdatabase AS INTEGER, ydatabase AS INTEGER
DIM SHARED aghost AS INTEGER, bghost AS INTEGER
DIM SHARED xprison AS INTEGER, yprison AS INTEGER
DIM SHARED startdemo AS INTEGER
DIM SHARED badpactime AS INTEGER, dist
DIM SHARED ega(16) AS INTEGER
DIM opendoor AS INTEGER, nextone(2) AS INTEGER, openorclose AS INTEGER
DIM levnum AS INTEGER, maxlev AS INTEGER
DIM compressed(300) AS INTEGER
DIM side AS INTEGER, kind AS INTEGER
DIM death(60, 21)
DIM kickghosta(memph) AS INTEGER, kickghostb(memph) AS INTEGER
DIM kickass(memph) AS INTEGER
DIM ddd AS INTEGER, TIMERbefore AS SINGLE
DIM file$

'defines type for LoadPcx
TYPE TH
MAN AS STRING * 1
VER AS STRING * 1
ENC AS STRING * 1
BIT AS STRING * 1
XLS AS INTEGER
YLS AS INTEGER
XMS AS INTEGER
YMS AS INTEGER
HRE AS INTEGER
VRE AS INTEGER
col AS STRING * 48
RES AS STRING * 1
PLA AS STRING * 1
BYT AS INTEGER
PAL AS INTEGER
FIL AS STRING * 58
END TYPE

RANDOMIZE TIMER                                 'ensure true random

FOR kind = 0 TO 15                              'this is for LoadPcx sub. makes my own ega palette
        READ ega(kind)
NEXT kind

DATA 11,0,0,14,10,12,8,7,3,0,0,0,0,0,0,0

FOR kind = 0 TO 24                              'pac death animation
        READ pacdeath(kind)
NEXT kind
          
DATA 0,1,2,3,0,1,2,3,0,1,2,3,0,1,2,4,5,6,7,8,10,9,11,13,12

FOR kind = 0 TO 13                              'phantom and bug death animation
        READ phantomdeath(kind)
NEXT kind

DATA 12,20,19,18,17,16,15,14,12,13,11,9,10,8

nextone(0) = 10: nextone(1) = 9                 'phantom prison door animation

FOR kind = 0 TO 2                               'pac animation
        FOR ydatabase = 0 TO 2
                FOR xdatabase = 0 TO 2
                        FOR side = 0 TO 7
                                READ mouth(side, xdatabase, ydatabase, kind)
                        NEXT side
                NEXT xdatabase
        NEXT ydatabase
NEXT kind
'order will be: up left right down (good/medium/bad)
DATA 00,00,00,00,00,00,00,00,09,10,11,10,09,10,11,10,00,00,00,00,00,00,00,00,00,01,02,01,00,01,02,01,00,00,00,00,00,00,00,00,06,07,08,07,06,07,08,07,00,00,00,00,00,00,00,00,03,04,05,04,03,04,05,04,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,21,10,23,10,21,10,23,10,00,00,00,00,00,00,00,00,12,01,14,01,12,01,14,01,00,00,00,00,00,00,00,00,18,07,20,07,18,07,20,07,00,00,00,00,00,00,00,00,15,04,17,04,15,04,17,04,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,21,22,23,22,21,22,23,22,00,00,00,00,00,00,00,00,12,13,14,13,12,13,14,13,00,00,00,00,00,00,00,00,18,19,20,19,18,19,20,19,00,00,00,00,00,00,00,00,15,16,17,16,15,16,17,16,00,00,00,00,00,00,00,00

FOR kind = 0 TO 2                               'phantom animation
        FOR ydatabase = 0 TO 2
                FOR xdatabase = 0 TO 2
                        FOR side = 0 TO 7
                                READ sheet(side, xdatabase, ydatabase, kind)
                        NEXT side
                NEXT xdatabase
        NEXT ydatabase
NEXT kind
                                                                                                                         
DATA 00,00,00,00,00,00,00,00,06,06,07,07,06,06,07,07,00,00,00,00,00,00,00,00,00,00,01,01,00,00,01,01,00,00,00,00,00,00,00,00,04,04,05,05,04,04,05,05,00,00,00,00,00,00,00,00,02,02,03,03,02,02,03,03,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,14,06,15,07,14,06,15,07,00,00,00,00,00,00,00,00,08,00,09,01,08,00,09,01,00,00,00,00,00,00,00,00,12,04,13,05,12,04,13,05,00,00,00,00,00,00,00,00,10,02,11,03,10,02,11,03,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,14,14,15,15,14,14,15,15,00,00,00,00,00,00,00,00,08,08,09,09,08,08,09,09,00,00,00,00,00,00,00,00,12,12,13,13,12,12,13,13,00,00,00,00,00,00,00,00,10,10,11,11,10,10,11,11,00,00,00,00,00,00,00,00

FOR ydatabase = 0 TO 2                          'bug animation
        FOR xdatabase = 0 TO 2
                FOR side = 0 TO 7
                        READ ass(side, xdatabase, ydatabase)
                NEXT side
        NEXT xdatabase
NEXT ydatabase

DATA 00,00,00,00,00,00,00,00,03,03,03,03,03,03,03,03,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,02,02,02,02,02,02,02,02,00,00,00,00,00,00,00,00,01,01,01,01,01,01,01,01,00,00,00,00,00,00,00,00

'this is for LoadMap and RandomMove subs. defines pac direction
pathsa(0) = -1: pathsa(1) = 0: pathsa(2) = 0: pathsa(3) = 1
pathsb(0) = 0: pathsb(1) = -1: pathsb(2) = 1: pathsb(3) = 0

FOR kind = 0 TO 255                             'these codes identify which graphic letter must be printed
        READ chrcodes(kind)
NEXT kind
                                                                                                   
'<SPACE>'(),-./0123456789:;?@ABCDEFGHIJKLMNOPQRSTUVWXYZ\
DATA 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,49,50,50,36,50,50,50,39,42,43,51,50,44,45,37,40,00,01,02,03,04,05,06,07,08,09,38,46,50,50,50,41,47,10,11,12,13,14,15,16
DATA 17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,50,48,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
DATA 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,52,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
DATA 50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50,50
                                                                                           
FOR ydatabase = 0 TO 2                          'this is for Wall and Find subs
        FOR xdatabase = 0 TO 2
                FOR side = 0 TO 3
                        READ corners(xdatabase, ydatabase, side)
                NEXT side
        NEXT xdatabase
NEXT ydatabase

DATA 0,0,0,0,24,24,38,24,0,0,0,0,24,24,24,38,0,0,0,0,38,24,38,38,0,0,0,0,24,38,38,38,0,0,0,0

FOR ydatabase = 0 TO 2                          'this is for HaveLunch sub
        FOR xdatabase = 0 TO 2
                FOR side = 0 TO 1
                        READ dinner(xdatabase, ydatabase, side)
                NEXT side
        NEXT xdatabase
NEXT ydatabase

DATA 0,0,24,30,0,0,30,24,0,0,32,24,0,0,24,32,0,0

FOR readfont = 0 TO 49                          'this is the database for the draw function in ViewWavyText sub
        READ font$(readfont)
NEXT readfont

DATA "bl6bd4c10u8e4r4f4d8g4l4h4be3bu1u3e1r3g4bd4br2e4d3g1l3"
DATA "bl6bd8c10u4r4u8l4e4r4d12r4d4l12"
DATA "bl6bu4c10u2e3r6f3d3g6r6d4l12u4e8l4d2l4"
DATA "bl6bd4c10u4r4d2f1r2e1u2h1l1u2r1e1u2h1l2g1d2l4u4e2r8f2d5g1f1d5g2l8h2"
DATA "bl6bd4c10u6e6r4d8r2d4l2d4l4u4l6be4e2d2l2"
DATA "bl6bd4c10d4r10e2u6h2l6u2r8u4l12d8f2r5d2l7"
DATA "bl6bd6c10f2r8e2u4h2l6u3e1r2f1r4u3h2l8g2d12bu2br4u1r3f1g1l2h1"
DATA "bl6bd8c10r4u4e8u4l12d4r8g8d4"
DATA "bl6bd6c10f2r8e2u4h2e2u4h2l8g2d4f2g2d4be2br2u1e1r2f1d1l4bu7u1e1r2f1d1l4"
DATA "bl6bd8c10f2r8e2u12h2l8g2d4f2r6d3g1l2h1l4d3bu10br4e1r2f1d1l3h1"
DATA "bl2bd4c10d4l4u10e6f6d10l4u4l4bu4r4h2g2bg1"
DATA "bl6bd8c10u16r9f3d2g3f3d2g3l9bu6br6l2bu6r2br2"
DATA "bl6bd4c10u8e4r4f4d2l4u2l4d8r4u2r4d2g4l4h4br2"
DATA "bl6bd8c10u16r8f4d8g4l8be4bu1u6r3f1d4g1l3bd2"
DATA "bl6bd8c10u16r12d4l8d2r4d4l4d2r8d4l12be2"
DATA "bl6bd8c10u16r12d4l8d2r4d4l4d6L4be2"
DATA "bl6bd4c10u8e4r4f4l8d8r4u4r4d4g4l4h4br2"
DATA "bl6bd8c10u16r4d6r4u6r4d16l4u6l4d6l4be2"
DATA "bl6bd8c10u4r4u8l4u4r12d4l4d8r4d4l12be2"
DATA "bl6bd4c10u4r4d4r4u8l8u4r12d12g4l4h4br2"
DATA "bl6bd8c10u16r4d8e4r4g6f6l4h4d4l4be2"
DATA "bl6bd8c10u16r4d12r8d4l12be2"
DATA "bl6bd8c10u16r4f2e2r4d16l4u8g2h2d8l4be2"
DATA "bl6bd8c10u16r4f4u4r4d16l4u6h4d10l4be2"
DATA "bl6bd4c10u8e4r4f4d8g4l4h4be2br2u4e1r2f1d4g1l2h1bd2"
DATA "bl6bd8c10u16r8f4d4g4l4d4l4bu8br4u4r3f1d2g1l3bd2"
DATA "bl6bd4c10u8e4r4f4d8g2f2l8h4be2br2u4e1r2f1d4g1l2h1bd2"
DATA "bl6bd8c10u16r8f4d4g4f4l4h4d4l4bu8br4u4r3f1d2g1l3bd2"
DATA "bl6bd8c10u4r6u2l4h2u6e2r10d4l6d2r4f2d6g2l10be2"
DATA "bl6bd8br4c10u12l4u4r12d4l4d12l4be2"
DATA "bl6bd6c10u14r4d12r4u12r4d14g2l8h2be2"
DATA "bl6bd4c10u12r4d10f2e2u10r4d12g4l4h4br2"
DATA "bl6bd8c10u16r4d10e2f2u10r4d16l4h2g2l4be2"
DATA "bl6bd8c10u4e4h4u4r2f4e4r2d4g4f4d4l2h4g4l2be2"
DATA "bl6bd8br4c10u8h4u4r2f4e4r2d4g4d8l4be2"
DATA "bl6bd8c10u4e8l8u4r12d4g8r8d4l12be2"
DATA "bl6bd8c10u10r4f4u4r4d10l4u2h4d6l4be2bu10c10l2u4r12d4l10bu2"
DATA "bl6bd8br4c10u4r4d4l4be2"
DATA "bl6bd8br4c10u4r4d4l4bu8u4r4d4l4"
DATA "bl6bd8br4c10bu12u4r4d6g4u2e2u2l2"
DATA "bl6bd8c10u4e12d4g12"
DATA "bl6bd8bu8c10u4e4r4f4d2g4d2l4u2e4h2l2d4l4br4bd6r4d2l4u2"
DATA "bl6bd8br5c10h5u6e5r5g5d6f5l5"
DATA "bl6bd8br7c10e5u6h5l5f5d6g5r5"
DATA "bl6bd8br4c10u4r4d6g4u2e2u2l2"
DATA "bl6bd2c10u4r12d4l12"
DATA "bl6bd8br4c10u4r4d6g4u2e2u2l2bu8u4r4d4l4"
DATA "bl6bd6c10f2r11e2u2l2d2l9h2u10e2r6f2d4g2u2h2l2g2d2f2r4e4u6h2l10g2d14"
DATA "bl6bu8c10d4f12u4h12"
DATA ""

FOR kind = 0 TO 169
        READ xx(kind), yy(kind), angle(kind)
NEXT kind

DATA -08,  -07,  057,  -06,  -05,  054,  -04,  -04,  051,  -02,  -02,  048,  000,  000,  045,  002,  001,  042,  004,  003,  039,  006,  005,  036,  008,  006,  033,  010,  008,  030,  012
DATA 010,  027,  014,  011,  024,  016,  012,  021,  018,  014,  018,  020,  015,  015,  022,  016,  012,  024,  017
DATA 009,  026,  018,  006,  028,  018,  003,  030,  019,  000,  032,  019,  -03,  034,  019,  -06,  036,  020,  -09
DATA 038,  019,  -12,  040,  019,  -15,  042,  019,  -18,  044,  018,  -21,  046,  018,  -24,  048,  017,  -27,  050
DATA 016,  -30,  052,  015,  -33,  054,  014,  -36,  056,  012,  -39,  058,  011,  -42,  060,  010,  -45,  062,  008
DATA -48,  064,  006,  -51,  066,  005,  -54,  068,  003,  -57,  070,  001,  -60,  072,  -01,  -57,  074,  -02,  -54
DATA 076,  -04,  -51,  078,  -06,  -48,  080,  -07,  -45,  082,  -09,  -42,  084,  -10,  -39,  086,  -12,  -36,  088
DATA -13,  -33,  090,  -15,  -30,  092,  -16,  -27,  094,  -17,  -24,  096,  -18,  -21,  098,  -19,  -18,  100,  -19
DATA -15,  102,  -20,  -12,  104,  -20,  -09,  106,  -20,  -06,  108,  -20,  -03,  110,  -20,  000,  112,  -20,  003
DATA 114,  -20,  006,  116,  -19,  009,  118,  -19,  012,  120,  -18,  015,  122,  -17,  018,  124,  -16,  021,  126
DATA -15,  024,  128,  -13,  027,  130,  -12,  030,  132,  -10,  033,  134,  -09,  036,  136,  -07,  039,  138,  -06,  042,  140,  -04,  045,  142
DATA -02,  048,  144,  000,  048,  146,  001,  045,  148,  003,  042,  150,  005,  039,  152,  006,  036,  154,  008,  033
DATA 156,  010,  030,  158,  011,  027,  160,  012,  024,  162,  014,  021,  164,  015,  018,  166,  016,  015,  168
DATA 017,  012,  170,  018,  009,  172,  018,  006,  174,  019,  003,  176,  019,  000,  178,  019,  -03,  180,  020,  -06
DATA 182,  019,  -09,  184,  019,  -12,  186,  019,  -15,  188,  018,  -18,  190,  018,  -21,  192,  017,  -24,  194
DATA 016,  -27,  196,  015,  -30,  198,  014,  -33,  200,  012,  -36,  202,  011,  -39,  204,  010,  -42,  206,  008,  -45
DATA 208,  006,  -48,  210,  005,  -51,  212,  003,  -54,  214,  001,  -57,  216,  -01,  -54,  218,  -02,  -51,  220
DATA -04,  -48,  222,  -06,  -45,  224,  -07,  -42,  226,  -09,  -39,  228,  -10,  -36,  230,  -12,  -33,  232,  -13,  -30
DATA 234,  -15,  -27,  236,  -16,  -24,  238,  -17,  -21,  240,  -18,  -18,  242,  -19,  -15,  244,  -19,  -12,  246
DATA -20,  -09,  248,  -20,  -06,  250,  -20,  -03,  252,  -20,  000,  254,  -20,  003,  256,  -20,  006,  258,  -20,  009
DATA 260,  -19,  012,  262,  -19,  015,  264,  -18,  018,  266,  -17,  021,  268,  -16,  024,  270,  -15,  027,  272
DATA -13,  030,  274,  -12,  033,  276,  -10,  036,  278,  -09,  039,  280,  -07,  042,  282,  -06,  045,  284,  -04,  048
DATA 286,  -02,  051,  288,  000,  051,  290,  001,  048,  292,  003,  045,  294,  005,  042,  296,  006,  039,  298
DATA 008,  036,  300,  010,  033,  302,  011,  030,  304,  012,  027,  306,  014,  024,  308,  015,  021,  310,  016,  018
DATA 312,  017,  015,  314,  018,  012,  316,  018,  009,  318,  019,  006,  320,  019,  003,  322,  019,  000,  324
DATA 020,  -03,  326,  019,  -06,  328,  019,  -09,  330,  019,  -12

SCREEN 7, , 0, 1                                '320x200 16 colors mode initialization

LoadPcx "default.pcx"                           'graphics loading

GET (68, 92)-(83, 107), tiles(0, 3)             'red face tile getting

GET (86, 124)-(95, 137), tiles(0, 4)            'food tile getting

GET (52, 109)-(65, 121), tiles(0, 5)            'arrow tiles getting
GET (69, 109)-(81, 121), tiles(0, 6)
GET (86, 109)-(99, 121), tiles(0, 7)
GET (103, 109)-(116, 121), tiles(0, 8)

GET (86, 58)-(101, 71), tiles(0, 9)             'phantom prison door tiles getting
GET (69, 75)-(84, 90), tiles(0, 10)

GET (35, 75)-(50, 90), tiles(0, 11)             'first map tiles getting
GET (52, 92)-(67, 107), tiles(0, 12)
GET (1, 109)-(16, 122), tiles(0, 13)
GET (18, 109)-(33, 122), tiles(0, 14)
GET (1, 58)-(16, 71), tiles(0, 15)
GET (18, 58)-(33, 71), tiles(0, 16)
GET (35, 58)-(50, 71), tiles(0, 17)
GET (52, 58)-(67, 73), tiles(0, 18)
GET (1, 75)-(16, 90), tiles(0, 19)
GET (18, 75)-(33, 90), tiles(0, 20)
GET (52, 75)-(67, 90), tiles(0, 21)
GET (1, 92)-(16, 107), tiles(0, 22)
GET (18, 92)-(33, 107), tiles(0, 23)
GET (35, 92)-(50, 105), tiles(0, 24)
GET (35, 109)-(48, 122), tiles(0, 25)

GET (230, 18)-(245, 33), tiles(0, 26)           'second map tiles getting
GET (247, 35)-(262, 50), tiles(0, 27)
GET (196, 52)-(211, 65), tiles(0, 28)
GET (213, 52)-(228, 65), tiles(0, 29)
GET (196, 1)-(211, 14), tiles(0, 30)
GET (213, 1)-(228, 14), tiles(0, 31)
GET (230, 1)-(245, 14), tiles(0, 32)
GET (247, 1)-(262, 16), tiles(0, 33)
GET (196, 18)-(211, 33), tiles(0, 34)
GET (213, 18)-(228, 33), tiles(0, 35)
GET (247, 18)-(262, 33), tiles(0, 36)
GET (196, 35)-(211, 50), tiles(0, 37)
GET (213, 35)-(228, 50), tiles(0, 38)
GET (230, 35)-(245, 48), tiles(0, 39)
GET (230, 52)-(243, 65), tiles(0, 40)

GET (230, 84)-(245, 99), tiles(0, 41)           'third map tiles getting
GET (247, 101)-(262, 116), tiles(0, 42)
GET (196, 118)-(211, 131), tiles(0, 43)
GET (213, 118)-(228, 131), tiles(0, 44)
GET (196, 67)-(211, 80), tiles(0, 45)
GET (213, 67)-(228, 80), tiles(0, 46)
GET (230, 67)-(245, 80), tiles(0, 47)
GET (247, 67)-(262, 82), tiles(0, 48)
GET (196, 84)-(211, 99), tiles(0, 49)
GET (213, 84)-(228, 99), tiles(0, 50)
GET (247, 84)-(262, 99), tiles(0, 51)
GET (196, 101)-(211, 116), tiles(0, 52)
GET (213, 101)-(228, 116), tiles(0, 53)
GET (230, 101)-(245, 114), tiles(0, 54)
GET (230, 118)-(243, 131), tiles(0, 55)

GET (103, 58)-(118, 73), tiles(0, 56)           'common tiles getting
GET (103, 75)-(116, 90), tiles(0, 57)
GET (86, 92)-(101, 105), tiles(0, 58)
GET (103, 92)-(116, 105), tiles(0, 59)
GET (69, 58)-(84, 71), tiles(0, 60)
GET (86, 75)-(101, 90), tiles(0, 61)

GET (267, 101)-(282, 116), tiles(0, 62)         'central tiles getting
GET (284, 101)-(299, 116), tiles(0, 63)
GET (301, 101)-(316, 116), tiles(0, 64)

GET (204, 142)-(211, 155), door(0, 0)           'L door graphics getting
GET (212, 142)-(227, 155), door(0, 1)
GET (204, 156)-(211, 171), door(0, 2)
GET (212, 156)-(227, 171), door(0, 3)
GET (261, 142)-(276, 155), door(0, 4)
GET (277, 142)-(286, 155), door(0, 5)
GET (261, 156)-(276, 171), door(0, 6)
GET (277, 156)-(286, 171), door(0, 7)
GET (228, 142)-(243, 155), door(0, 8)
GET (244, 142)-(260, 155), door(0, 9)
GET (228, 156)-(243, 171), door(0, 10)
GET (244, 156)-(260, 171), door(0, 11)

GET (196, 133)-(203, 140), boxes(0, 0)          'window boxes graphics getting
GET (205, 133)-(212, 140), boxes(0, 1)
GET (214, 133)-(221, 140), boxes(0, 2)
GET (223, 133)-(230, 140), boxes(0, 3)
GET (232, 133)-(239, 140), boxes(0, 4)
GET (241, 133)-(248, 140), boxes(0, 5)
GET (250, 133)-(257, 140), boxes(0, 6)
GET (259, 133)-(266, 140), boxes(0, 7)
GET (268, 133)-(275, 140), boxes(0, 8)

GET (2, 124)-(9, 131), font(0, 0)               'font graphics getting
GET (10, 124)-(17, 131), font(0, 1)
GET (18, 124)-(25, 131), font(0, 2)
GET (26, 124)-(33, 131), font(0, 3)
GET (34, 124)-(41, 131), font(0, 4)
GET (42, 124)-(49, 131), font(0, 5)
GET (50, 124)-(57, 131), font(0, 6)
GET (58, 124)-(65, 131), font(0, 7)
GET (66, 124)-(73, 131), font(0, 8)
GET (74, 124)-(81, 131), font(0, 9)
GET (2, 133)-(9, 140), font(0, 10)
GET (10, 133)-(17, 140), font(0, 11)
GET (18, 133)-(25, 140), font(0, 12)
GET (26, 133)-(33, 140), font(0, 13)
GET (34, 133)-(41, 140), font(0, 14)
GET (42, 133)-(49, 140), font(0, 15)
GET (50, 133)-(57, 140), font(0, 16)
GET (58, 133)-(65, 140), font(0, 17)
GET (66, 133)-(73, 140), font(0, 18)
GET (74, 133)-(81, 140), font(0, 19)
GET (2, 142)-(9, 149), font(0, 20)
GET (10, 142)-(17, 149), font(0, 21)
GET (18, 142)-(25, 149), font(0, 22)
GET (26, 142)-(33, 149), font(0, 23)
GET (34, 142)-(41, 149), font(0, 36)
GET (42, 142)-(49, 149), font(0, 24)
GET (50, 142)-(57, 149), font(0, 25)
GET (58, 142)-(65, 149), font(0, 26)
GET (66, 142)-(73, 149), font(0, 27)
GET (74, 142)-(81, 149), font(0, 28)
GET (2, 151)-(9, 158), font(0, 29)
GET (10, 151)-(17, 158), font(0, 30)
GET (18, 151)-(25, 158), font(0, 31)
GET (26, 151)-(33, 158), font(0, 32)
GET (34, 151)-(41, 158), font(0, 33)
GET (42, 151)-(49, 158), font(0, 34)
GET (50, 151)-(57, 158), font(0, 35)
GET (58, 151)-(65, 158), font(0, 37)
GET (66, 151)-(73, 158), font(0, 38)
GET (74, 151)-(81, 158), font(0, 39)
GET (2, 160)-(9, 167), font(0, 40)
GET (10, 160)-(17, 167), font(0, 41)
GET (18, 160)-(25, 167), font(0, 42)
GET (26, 160)-(33, 167), font(0, 43)
GET (34, 160)-(41, 167), font(0, 44)
GET (42, 160)-(49, 167), font(0, 45)
GET (50, 160)-(57, 167), font(0, 46)
GET (58, 160)-(65, 167), font(0, 47)
GET (66, 160)-(73, 167), font(0, 48)
GET (74, 160)-(81, 167), font(0, 49)
GET (2, 169)-(9, 176), font(0, 50)
GET (10, 169)-(17, 176), font(0, 51)
GET (19, 169)-(26, 176), font(0, 52)

GET (20, 20)-(37, 37), death(0, 0)              'pac death graphics getting
GET (1, 39)-(18, 56), death(0, 1)
GET (58, 39)-(75, 56), death(0, 2)
GET (39, 1)-(56, 18), death(0, 3)
GET (77, 39)-(93, 56), death(0, 4)
GET (95, 39)-(111, 56), death(0, 5)
GET (113, 39)-(129, 56), death(0, 6)
GET (131, 39)-(147, 56), death(0, 7)

GET (153, 1)-(170, 18), death(0, 8)             'common death graphics getting
GET (172, 0)-(190, 18), death(0, 9)
GET (153, 20)-(170, 37), death(0, 10)
GET (172, 19)-(192, 38), death(0, 11)
GET (153, 39)-(170, 56), death(0, 12)
GET (172, 39)-(193, 56), death(0, 13)

GET (104, 134)-(118, 151), death(0, 14)         'phantom and bug death graphics getting
GET (104, 135)-(118, 151), death(0, 15)
GET (104, 136)-(118, 151), death(0, 16)
GET (104, 137)-(118, 151), death(0, 17)
GET (104, 138)-(118, 151), death(0, 18)
GET (104, 139)-(118, 151), death(0, 19)
GET (104, 140)-(118, 151), death(0, 20)

GET (1, 1)-(18, 18), pac(0, 0)                  'good pac graphics getting
GET (20, 1)-(37, 18), pac(0, 1)
GET (39, 1)-(56, 18), pac(0, 2)
GET (58, 1)-(75, 18), pac(0, 3)
GET (1, 20)-(18, 37), pac(0, 4)
GET (20, 20)-(37, 37), pac(0, 5)
GET (39, 20)-(56, 37), pac(0, 6)
GET (58, 20)-(75, 37), pac(0, 7)
GET (1, 39)-(18, 56), pac(0, 8)
GET (20, 39)-(37, 56), pac(0, 9)
GET (39, 39)-(56, 56), pac(0, 10)
GET (58, 39)-(75, 56), pac(0, 11)

GET (120, 58)-(137, 75), pac(0, 12)             'bad pac graphics getting
GET (139, 58)-(156, 75), pac(0, 13)
GET (158, 58)-(175, 75), pac(0, 14)
GET (177, 58)-(194, 75), pac(0, 15)
GET (120, 77)-(137, 94), pac(0, 16)
GET (139, 77)-(156, 94), pac(0, 17)
GET (158, 77)-(175, 94), pac(0, 18)
GET (177, 77)-(194, 94), pac(0, 19)
GET (120, 96)-(137, 113), pac(0, 20)
GET (139, 96)-(156, 113), pac(0, 21)
GET (158, 96)-(175, 113), pac(0, 22)
GET (177, 96)-(194, 113), pac(0, 23)

GET (77, 1)-(94, 18), phantom(0, 0)             'bad phantom graphics getting
GET (96, 1)-(113, 18), phantom(0, 1)
GET (115, 1)-(132, 18), phantom(0, 2)
GET (134, 1)-(151, 18), phantom(0, 3)
GET (77, 20)-(94, 37), phantom(0, 4)
GET (96, 20)-(113, 37), phantom(0, 5)
GET (115, 20)-(132, 37), phantom(0, 6)
GET (134, 20)-(151, 37), phantom(0, 7)

GET (120, 115)-(137, 132), phantom(0, 8)        'good phantom graphics getting
GET (139, 115)-(156, 132), phantom(0, 9)
GET (158, 115)-(175, 132), phantom(0, 10)
GET (177, 115)-(194, 132), phantom(0, 11)
GET (120, 134)-(137, 151), phantom(0, 12)
GET (139, 134)-(156, 151), phantom(0, 13)
GET (158, 134)-(175, 151), phantom(0, 14)
GET (177, 134)-(194, 151), phantom(0, 15)

GET (120, 153)-(137, 168), bug(0, 0)            'bug graphics getting
GET (139, 153)-(154, 170), bug(0, 1)
GET (158, 153)-(175, 168), bug(0, 2)
GET (177, 153)-(192, 170), bug(0, 3)

'palette initialization

PALETTE 13, 8
PALETTE 15, 8
PALETTE 11, 7
PALETTE 3, 0
PALETTE 6, 2
PALETTE 9, 8

'menu initialization

menu:

KEY(11) OFF: KEY(12) OFF: KEY(13) OFF: KEY(14) OFF: KEY(8) OFF

CLOSE '#2

file$ = "default.txt"
ddd = 0: points = -1
VIEW: CLS
VIEW SCREEN (50, 0)-(275, 199)                  'defines scroll window
BlankScreen

ViewText 92, 40, "MADMIX GAME V1.2"
ViewText 92, 64, "1...START GAME  "
ViewText 92, 80, "2...LOAD CUSTOM "
ViewText 92, 96, "3...HALL OF FAME"
ViewText 92, 112, "4...CREDITS     "
ViewText 92, 128, "5...EXIT        "
ViewText 84, 156, "QBASIC VERSION BY"
ViewText 84, 165, "ENRIQUE HUERTA"

PALETTE 11, 7: PALETTE 0, 0'''

DO: LOOP UNTIL INKEY$ = ""                      'clears keyboard buffer

TIMER ON
ON TIMER(5) GOSUB activatedemo                  'five seconds to demo

DO WHILE (Choice = 0 AND startdemo = 0)
        PCOPY 0, 1
LOOP

TIMER OFF

SELECT CASE chosen
        CASE 1
        CASE 2
                file$ = FileBrowser$("FILE NAME:", 40)
                IF file$ = "" THEN GOTO menu
        CASE 3
                BlankScreen
                CheckRecord
                LoadRecords
                GOTO menu
        CASE 4
                VIEW: CLS
                ViewWavyText 100, "PROGRAMMER: ENRIQUE HUERTA MEZQUITA, CONTACT ME AT ENRIQUEMAIL@MIXMAIL.COM, "
                GOTO menu
        CASE 5
                GOTO escape
END SELECT

'Game Initialization

OPEN file$ FOR INPUT AS #2
INPUT #2, maxlev

VIEW: CLS : PAINT (0, 0), 3
VIEW SCREEN (50, 0)-(275, 199)                  'defines scroll window

lives = 3: points = 0: name$ = "": levnum = 0

KEY(8) ON                                       'activates F8 = exit key

ON KEY(8) GOSUB escape                          'intercept keys
ON KEY(11) GOSUB arriba
ON KEY(12) GOSUB izquierda
ON KEY(13) GOSUB derecha
ON KEY(14) GOSUB abajo

loadlevel:

ERASE kickass

IF levnum > (maxlev - 1) THEN levnum = 0: CLOSE #2: OPEN file$ FOR INPUT AS #2: INPUT #2, maxlev

'prisons = 0
xprison = 0
foodleft = 0

LoadMap file$                                   'map matrix reading

openorclose = map(xprison, yprison)
lives = lives + addlife
Abefore = A: Bbefore = B

'FOR kind = 0 TO prisons
        'opendoor(kind) = INT(RND * 40)
'NEXT kind

realpoints = points: BlankScreen: ViewPoints: NextStage

restart:

IF lives = -1 THEN
        lives = 0: realpoints = points: BlankScreen: ViewPoints: GameOver: BlankScreen: PCOPY 0, 1: PALETTE 11, 7: PALETTE 0, 0
        IF (chosen - 2) THEN CheckRecord: BlankScreen: LoadRecords
        GOTO menu
END IF

factor = 4                                      'phantoms loop
flip = 1                                        'phantoms want to kill pac. if it is -1 phantoms will escape
accuracy = 3                                    'phantom intelligence accuracy
character = 0                                   'good/medium/bad character
timeleft = 0                                    'time left to mutate

newgame = 1                                     'if newgame is true we have to press any key because of Ready sub
pacisalive = 1                                  'if pacisalive is equal to one then phantoms can eat pac. if pacisalive is grower then pac can eat phantoms. if pacisalive is equal to zero then pac is dead
backcount = 0                                   'changes graphics making the death animation effect
opendoor = 0                                    'time counter to open and close phantom prison door
count = 5                                       'changes graphics making the animation effect
tryadda = adda: tryaddb = addb                  'their values say to us the direction we want to go
A = Abefore: B = Bbefore                        'pac coordinates and pac coordinates buffer are the same value
realpoints = points                             'points refresh

'FOR kind = 0 TO prisons
map(xprison, yprison) = openorclose             'prison door is restored as at the beginning
'NEXT kind

FOR i = 0 TO (phantoms + bugs):
        ghosta(i) = aghost: ghostb(i) = bghost  'all phantoms start over the same location
        RandomMove                              'phantom starts moving randomly
NEXT i

DO

        TIMERbefore = TIMER                     'count the time elapsed between two frames

        IF startdemo = 0 THEN KEY(11) STOP: KEY(12) STOP: KEY(13) STOP: KEY(14) STOP': KEY(1) STOP: KEY(2) STOP

        CLS 1
        
        'FOR kind = 0 TO prisons
        IF xprison THEN
                opendoor = opendoor + 1
                IF opendoor > 75 THEN
                        opendoor = 0
                        map(xprison, yprison) = nextone(map(xprison, yprison) - 9)
                        'prison door can be put in the middle
                        SELECT CASE map(xprison, yprison)
                                CASE 32: map(0, yprison) = nextone(map(0, yprison) - 9)
                                CASE 1: map(33, yprison) = nextone(map(33, yprison) - 9)
                        END SELECT
                END IF
        END IF
        'NEXT kind

        FOR i = 0 TO (phantoms + bugs)
                SELECT CASE ghosta(i)
                        CASE IS < -72: ghosta(i) = ghosta(i) + 512
                        CASE IS > 440: ghosta(i) = ghosta(i) - 512
                END SELECT
                SELECT CASE (56 + ghosta(i) - A)
                        CASE IS > 256: rewind(i) = -512
                        CASE IS < -256: rewind(i) = 512
                        CASE ELSE: rewind(i) = 0
                END SELECT
                SELECT CASE (56 + kickghosta(i) - A)
                        CASE IS > 256: kickrewind(i) = -512
                        CASE IS < -256: kickrewind(i) = 512
                        CASE ELSE: kickrewind(i) = 0
                END SELECT

                dist = ((A - 56 - ghosta(i) - rewind(i)) ^ 2 + (B - 56 - ghostb(i)) ^ 2)
                IF dist < 196 AND (i <= phantoms OR factor - 4) AND dooropening = 0 THEN pacisalive = 1 - flip
                
                IF pacisalive > 1 THEN
                        pacisalive = 1: kickass(i) = 13
                        kickghosta(i) = ghosta(i): kickghostb(i) = ghostb(i)
                        ghosta(i) = aghost: ghostb(i) = bghost
                        RandomMove
                        points = points + 60
                        ELSE
                        IF (INT(ghosta(i) / 16) = (ghosta(i) / 16) AND INT(ghostb(i) / 16) = (ghostb(i) / 16)) AND newgame = 0 THEN AI
                END IF
                ghosta(i) = ghosta(i) + addgha(i) * ChooseFactor: ghostb(i) = ghostb(i) + addghb(i) * ChooseFactor
        NEXT i
                                
        SELECT CASE timeleft
                CASE 1: factor = 4: flip = 1: accuracy = 3: character = 0: timeleft = 0
                FOR i = 0 TO phantoms:
                        ghosta(i) = ghosta(i) - addgha(i) * (ghosta(i) / 4 - INT(ghosta(i) / 4)) * 4
                        ghostb(i) = ghostb(i) - addghb(i) * (ghostb(i) / 4 - INT(ghostb(i) / 4)) * 4
                        addgha(i) = -addgha(i): addghb(i) = -addghb(i)
                NEXT i
                CASE 50: character = 1: timeleft = timeleft - 1
                CASE IS > 0: timeleft = timeleft - 1
        END SELECT

        IF dopath THEN dopath = dopath - 1: tryadda = doadda: tryaddb = doaddb
                            
        IF pacisalive THEN
                Abefore = A: Bbefore = B
                IF (INT((A + 8) / 16) = ((A + 8) / 16) AND INT((B + 8) / 16) = ((B + 8) / 16)) OR (tryadda = -adda AND adda <> 0) OR (tryaddb = -addb AND addb <> 0) THEN
                        IF Find = 2 THEN adda = tryadda: addb = tryaddb
                END IF
                A = A + adda: B = B + addb
                Wall
                'this is the previous code. it is faster but L door cannot be put in the middle
                'SELECT CASE dooropening
                        'CASE -6: map(xopening, yopening) = -109: map(xopening + 1, yopening) = -10: dooropening = dooropening + 1
                        'CASE -3: map(xopening, yopening) = -5: map(xopening + 1, yopening) = 98: dooropening = dooropening + 1
                        'CASE IS < 0: dooropening = dooropening + 1
                        'CASE 6: map(xopening, yopening) = -109: map(xopening + 1, yopening) = -10: dooropening = dooropening - 1
                        'CASE 3: map(xopening, yopening) = 99: map(xopening + 1, yopening) = -6: dooropening = dooropening - 1
                        'CASE IS > 0: dooropening = dooropening - 1
                'END SELECT
                SELECT CASE dooropening         'Map numbers identifiers for the door: -5, 98 = Left Door  ; -109, -10 = Middle Door \/; 99, -6 = Right Door 
                        CASE -6: dooropening = dooropening + 1
                        SELECT CASE xopening
                                CASE -1: map(31, yopening) = -109: map(32, yopening) = -10: map(0, yopening) = -10
                                CASE 0: map(32, yopening) = -109: map(0, yopening) = -109: map(1, yopening) = -10: map(33, yopening) = -10
                                CASE 1: map(33, yopening) = -109: map(1, yopening) = -109: map(2, yopening) = -10
                                CASE ELSE: map(xopening, yopening) = -109: map(xopening + 1, yopening) = -10
                        END SELECT
                        CASE -3: dooropening = dooropening + 1
                        SELECT CASE xopening
                                CASE -1: map(31, yopening) = -5: map(32, yopening) = 98: map(0, yopening) = 98
                                CASE 0: map(32, yopening) = -5: map(33, yopening) = 98: map(1, yopening) = 98: map(xopening, yopening) = -5
                                CASE 1: map(33, yopening) = -5: map(2, yopening) = 98: map(xopening, yopening) = -5
                                CASE ELSE: map(xopening + 1, yopening) = 98: map(xopening, yopening) = -5
                        END SELECT
                        CASE IS < 0: dooropening = dooropening + 1
                        CASE 6: map(xopening, yopening) = -109: dooropening = dooropening - 1
                        SELECT CASE xopening
                                CASE 31: map(32, yopening) = -10: map(0, yopening) = -10
                                CASE 32: map(0, yopening) = -109: map(1, yopening) = -10: map(33, yopening) = -10
                                CASE 33: map(1, yopening) = -109: map(2, yopening) = -10
                                CASE ELSE: map(xopening + 1, yopening) = -10
                        END SELECT
                        CASE 3: map(xopening, yopening) = 99: dooropening = dooropening - 1
                        SELECT CASE xopening
                                CASE 31: map(32, yopening) = -6: map(0, yopening) = -6
                                CASE 32: map(0, yopening) = 99: map(1, yopening) = -6: map(33, yopening) = -6
                                CASE 33: map(1, yopening) = 99: map(2, yopening) = -6
                                CASE ELSE: map(xopening + 1, yopening) = -6
                        END SELECT
                        CASE IS > 0: dooropening = dooropening - 1
                END SELECT
                HaveLunch
                MoveScreen
                'may be it is better to use mouth(count, INT((adda + 4) / 8) + INT((addb + 4) / 8) + 2 * ABS(addb / 4), character) to optimize
                PUT (152, 92), pac(0, mouth(count, (adda + 4) / 4, (addb + 4) / 4, character)), OR
                ELSE
                MoveScreen
                PUT (152, 92), death(0, pacdeath(backcount)), OR
                backcount = backcount + 1: IF backcount > 25 THEN lives = lives - 1: GOTO restart
        END IF

        FOR i = 0 TO (phantoms + bugs)
                IF (ghosta(i) - A + rewind(i)) > -144 AND (ghosta(i) - A + rewind(i)) < 32 AND (ghostb(i) - B) > -144 AND (ghostb(i) - B) < 35 THEN
                        IF i > phantoms THEN
                                PUT (ghosta(i) + 208 - A + rewind(i), ghostb(i) + 148 - B), bug(0, ass(count, addgha(i) + 1, addghb(i) + 1)), OR
                                ELSE
                                PUT (ghosta(i) + 208 - A + rewind(i), ghostb(i) + 148 - B), phantom(0, sheet(count, addgha(i) + 1, addghb(i) + 1, character)), OR
                        END IF
                END IF
                IF kickass(i) THEN
                        IF (kickghosta(i) - A + kickrewind(i)) > -144 AND (kickghosta(i) - A + kickrewind(i)) < 32 AND (kickghostb(i) - B) > -144 AND (kickghostb(i) - B) < 35 THEN
                                PUT (kickghosta(i) + 208 - A + kickrewind(i), kickghostb(i) + 148 - B), death(0, phantomdeath(kickass(i))), OR
                        END IF
                        kickass(i) = kickass(i) - 1
                        'SOUND 100, .1
                END IF
        NEXT i

        SELECT CASE A: CASE IS < -16: A = A + 512: CASE IS > 496: A = A - 512: END SELECT
        
        count = count + 1: IF count > 7 THEN count = 0

        LINE (81, 21)-(242, 182), 3, B: PAINT (67, 17), 3

        ViewPoints

        'demo data compression will be -40 = left, 40 = right, -04 = up, 04 = down
        IF startdemo THEN
                tryadda = FIX(compressed(ddd) / 10)
                tryaddb = (1 - ABS(FIX(compressed(ddd) / 40))) * compressed(ddd)
                IF ddd MOD 2 THEN ViewText 190, 170, "DEMO"
                ddd = ddd + 1: IF ddd > 299 THEN ddd = 0: levnum = levnum + 1: IF levnum <> 6 THEN GOSUB nextstagedemo: GOTO loadlevel ELSE GOTO finishdemo
        END IF

        IF newgame THEN
                PALETTE 0, 2: newgame = 0
                IF startdemo = 0 THEN Ready
                ELSE
                PCOPY 0, 1
        END IF

        IF foodleft = 0 THEN levnum = levnum + 1: GOTO loadlevel

        DO: LOOP UNTIL TIMER > TIMERbefore      'minimum time elapsed between two frames will be 0.01 seconds

        IF startdemo = 0 THEN KEY(11) ON: KEY(12) ON: KEY(13) ON: KEY(14) ON': KEY(1) ON: KEY(2) ON
        
LOOP WHILE (INKEY$ = "" OR startdemo = 0)

finishdemo:
        CLOSE #1
        'DO: LOOP UNTIL INKEY$ = ""              'clears keyboard buffer
        startdemo = 0: GOTO menu
arriba:
        tryaddb = -4: tryadda = 0
        RETURN
izquierda:
        tryadda = -4: tryaddb = 0
        RETURN
derecha:
        tryadda = 4: tryaddb = 0
        RETURN
abajo:
        tryaddb = 4: tryadda = 0
        RETURN
escape:
        null$ = Alert("HAVE A NICE DAY")
        SCREEN 0: WIDTH 80: CLS
        PRINT "FOR MORE FUN VISIT MY OWN PAGE HTTP://WWW11.BRINKSTER.COM/FREESOURCE"
        CLOSE : END
activatedemo:
        OPEN "demo.txt" FOR INPUT AS #1
        GOSUB nextstagedemo
        startdemo = 1
        chosen = 1
        RETURN
nextstagedemo:
        FOR kind = 0 TO 299
                INPUT #1, compressed(kind)
        NEXT kind
        RETURN
errortrapping:
        CLOSE
        SELECT CASE ERR
                CASE 53:
                null$ = Alert$("ERROR 53:FILE NOT FOUND")
                RESUME menu
                CASE 64:
                null$ = Alert$("ERROR 64:BAD FILENAME")
                RESUME menu
                CASE 75:
                null$ = Alert$("ERROR 75:PATH/FILE ACCESS ERROR")
                RESUME menu
                CASE 76:
                null$ = Alert$("ERROR 76:PATH NOT FOUND")
                RESUME menu
                'CASE 70:
                'null$ = Alert$("ERROR 70:PERMISSION DENIED")
                'RESUME menu
                'CASE 71:
                'null$ = Alert$("ERROR 71:DISK NOT READY")
                'RESUME menu
                CASE ELSE:
                null$ = Alert$("SEVERAL ERROR" + STR$(ERR) + ":CANNOT CONTINUE")
                SCREEN 0: WIDTH 80: CLS
                END
        END SELECT

SUB AI
        'converts screen coordinates to matrix coordinates
        ghostx = (ghosta(i) + 80) / 16
        ghosty = (ghostb(i) + 80) / 16

        'if bug is visible he will put points
        IF map(ghostx, ghosty) = -7 AND i > phantoms AND (ghosta(i) - A + rewind(i) > -144) AND (ghosta(i) - A + rewind(i)) < 32 AND (ghostb(i) - B) > -144 AND (ghostb(i) - B) < 35 THEN
                map(ghostx, ghosty) = 4: foodleft = foodleft + 1
        END IF

        'if this is equal to zero then phantom behaves randomly ([1/50] probit)
        'IF INT(RND * 50) = 0 AND map(ghostx, ghosty) < 9 THEN RandomMove: EXIT SUB

        'intelligence accuracy increases when phantom is nearby to pac
        IF dist < 64 * 64 OR character > 0 THEN probit = INT(RND * accuracy) ELSE probit = 0

        SELECT CASE ABS(addghb(i))
                'phantom is moving horizontally
                CASE 0
                IF map(ghostx + addgha(i), ghosty) < 10 THEN updown = updown + 1
                IF map(ghostx, ghosty - 1) < 10 THEN updown = updown + 2
                IF map(ghostx, ghosty + 1) < 10 THEN updown = updown + 4
                SELECT CASE updown
                        CASE 0                  'no exits
                        addgha(i) = -addgha(i)
                        CASE 2                  'exit above
                        addgha(i) = 0: addghb(i) = -1
                        CASE 4                  'exit below
                        addgha(i) = 0: addghb(i) = 1
                        CASE 3                  'exits above, in front
                        IF probit = 0 THEN
                                probit = INT(RND * 2)
                                addgha(i) = addgha(i) * probit: addghb(i) = probit - 1
                                ELSE
                                IF ghosty * flip > (INT(B / 16) + 2) * flip THEN addgha(i) = 0: addghb(i) = -1
                        END IF
                        CASE 5                  'exits below, in front
                        IF probit = 0 THEN
                                probit = INT(RND * 2)
                                addgha(i) = addgha(i) * probit: addghb(i) = 1 - probit
                                ELSE
                                IF ghosty * flip < (INT(B / 16) + 2) * flip THEN addgha(i) = 0: addghb(i) = 1
                        END IF
                        CASE 6                  'exits above, below
                        addgha(i) = 0
                        IF probit = 0 THEN
                                probit = INT(RND * 2)
                                addghb(i) = probit * 2 - 1
                                ELSE
                                IF ghosty * flip > (INT(B / 16) + 2) * flip THEN addghb(i) = -1 ELSE addghb(i) = 1
                        END IF
                        CASE 7                  'exits above, below, in front
                        IF probit = 0 THEN
                                probit = INT(RND * 3) - 1
                                addghb(i) = probit: addgha(i) = addgha(i) * (1 - ABS(addghb(i)))
                                ELSE
                                IF ghosty * flip > (INT(B / 16) + 2) * flip THEN addgha(i) = 0: addghb(i) = -1
                                IF ghosty * flip < (INT(B / 16) + 2) * flip THEN addgha(i) = 0: addghb(i) = 1
                        END IF
                END SELECT
                'phantom is moving vertically
                CASE 1
                IF map(ghostx, ghosty + addghb(i)) < 10 THEN leftright = leftright + 1
                IF map(ghostx - 1, ghosty) < 10 THEN leftright = leftright + 2
                IF map(ghostx + 1, ghosty) < 10 THEN leftright = leftright + 4
                SELECT CASE leftright
                        CASE 0                  'no exits
                        addghb(i) = -addghb(i)
                        CASE 2                  'exit on the left
                        addghb(i) = 0: addgha(i) = -1
                        CASE 4                  'exit on the right
                        addghb(i) = 0: addgha(i) = 1
                        CASE 3                  'exits on the left, in front
                        IF probit = 0 THEN
                                probit = INT(RND * 2)
                                addghb(i) = addghb(i) * probit: addgha(i) = probit - 1
                                ELSE
                                IF ghostx * flip + rewind(i) > (INT(A / 16) + 2) * flip THEN addghb(i) = 0: addgha(i) = -1
                        END IF
                        CASE 5                  'exits on the right, in front
                        IF probit = 0 THEN
                                probit = INT(RND * 2)
                                addghb(i) = addghb(i) * probit: addgha(i) = 1 - probit
                                ELSE
                                IF ghostx * flip + rewind(i) < (INT(A / 16) + 2) * flip THEN addghb(i) = 0: addgha(i) = 1
                        END IF
                        CASE 6                  'exits on the left, on the right
                        addghb(i) = 0
                        IF probit = 0 THEN
                                probit = INT(RND * 2)
                                addgha(i) = probit * 2 - 1
                                ELSE
                                IF ghostx * flip + rewind(i) > (INT(A / 16) + 2) * flip THEN addgha(i) = -1 ELSE addgha(i) = 1
                        END IF
                        CASE 7                  'exits on the left, on the right, in front
                        IF probit = 0 THEN
                                probit = INT(RND * 3) - 1
                                addgha(i) = probit: addghb(i) = addghb(i) * (1 - ABS(addgha(i)))
                                ELSE
                                IF ghostx * flip + rewind(i) > (INT(A / 16) + 2) * flip THEN addghb(i) = 0: addgha(i) = -1
                                IF ghostx * flip + rewind(i) < (INT(A / 16) + 2) * flip THEN addghb(i) = 0: addgha(i) = 1
                        END IF
                END SELECT
        END SELECT
END SUB

FUNCTION Alert$ (txt$)
        PCOPY 1, 0
        txtlen = LEN(txt$)
        IF txtlen > 24 THEN midwidth = 12 ELSE midwidth = txtlen / 2
        ViewWindow 19 - midwidth, 11, 21 + midwidth, 15 + INT(txtlen / 25)
        FOR f = 0 TO INT(txtlen / 24)
                ViewText 156 - midwidth * 8, 104 + f * 9, MID$(txt$, f * 24 + 1, 24)
        NEXT f
        PCOPY 0, 1
        WHILE push$ = "": push$ = INKEY$: WEND
        Alert$ = push$
END FUNCTION

SUB BlankScreen
        CLS
        PAINT (67, 17), 3
        LINE (81, 21)-(242, 182), 7, B
        PAINT (87, 37), 7
END SUB

SUB CheckRecord
        OPEN "records.txt" FOR APPEND AS #1: CLOSE #1
        OPEN "records.txt" FOR INPUT AS #1
                WHILE NOT EOF(1)
                        INPUT #1, hallpoints(insert), hallnames$(insert)
                        insert = insert + 1
                WEND
        CLOSE #1
        FOR insert = 4 TO 0 STEP -1
                IF hallpoints(insert) <= points THEN
                        hallpoints(insert + 1) = hallpoints(insert): hallnames$(insert + 1) = hallnames$(insert)
                        ELSE
                        IF insert < 4 THEN name$ = FileBrowser("YOUR NAME:", 10)
                        hallpoints(insert + 1) = points: hallnames$(insert + 1) = name$ + STRING$(10 - LEN(name$), 46)
                        EXIT FOR
                END IF
                IF insert = 0 THEN
                        name$ = FileBrowser("YOUR NAME:", 10)
                        hallpoints(0) = points: hallnames$(0) = name$ + STRING$(10 - LEN(name$), 46)
                END IF
        NEXT insert
        OPEN "records.txt" FOR OUTPUT AS #1
                FOR insert = 0 TO 4
                        IF hallnames$(insert) = "" THEN hallnames$(insert) = STRING$(10, 46)
                        PRINT #1, hallpoints(insert), hallnames$(insert)
                NEXT insert
        CLOSE #1
END SUB

FUNCTION Choice
        LookForKey$ = INKEY$
        SELECT CASE VAL(LookForKey$)
                CASE 1 TO 5: Choice = 1: startdemo = 0: chosen = VAL(LookForKey$)
                CASE ELSE: Choice = 0
        END SELECT
END FUNCTION

FUNCTION ChooseFactor
        IF i > phantoms THEN ChooseFactor = 2 ELSE ChooseFactor = factor
END FUNCTION

FUNCTION FileBrowser$ (txt$, txtmax)
        ViewWindow 7, 10, 32, 14
        ViewText 64, 96, txt$
        DO: LOOP UNTIL INKEY$ = ""                      'clears keyboard buffer
        WHILE LookForKey$ <> CHR$(13) AND LookForKey$ <> CHR$(27)
                PCOPY 0, 1
                DO: LookForKey$ = UCASE$(INPUT$(1)): LOOP WHILE (LEN(txtwrote$) = 0 AND ASC(LookForKey$) = 8)
                SELECT CASE ASC(LookForKey$)
                        CASE 8:
                                txtwrote$ = LEFT$(txtwrote$, LEN(txtwrote$) - 1)
                                ViewText 143, 96, RIGHT$(txtwrote$, 12) + RIGHT$(txt$, 1) + CHR$(32)
                        CASE 13:
                                FileBrowser$ = txtwrote$
                        CASE 27:
                                FileBrowser$ = ""
                        CASE IS <> 13:
                                SELECT CASE LEN(txtwrote$)
                                        CASE IS >= txtmax
                                        CASE IS < 12:
                                        txtwrote$ = txtwrote$ + LookForKey$
                                        ViewText 143, 96, RIGHT$(txtwrote$, LEN(txtwrote$)) + RIGHT$(txt$, 1) + CHR$(32)
                                        CASE IS < txtmax:
                                        txtwrote$ = txtwrote$ + LookForKey$
                                        ViewText 143, 96, RIGHT$(txtwrote$, 12) + RIGHT$(txt$, 1) + CHR$(32)
                                END SELECT
                END SELECT
        WEND
END FUNCTION

FUNCTION Find
        FOR side = 0 TO 2 STEP 2
                SELECT CASE map(INT((A + tryadda + corners((tryadda + 4) / 4, (tryaddb + 4) / 4, 0 + side)) / 16), INT((B + tryaddb + corners((tryadda + 4) / 4, (tryaddb + 4) / 4, 1 + side)) / 16))
                        CASE 99, 98
                        FI = FI + 1
                        CASE IS < 11
                        FI = FI + 1
                END SELECT
        NEXT side
        Find = FI
END FUNCTION

SUB GameOver
        DIM TIMERbefore AS SINGLE
        TIMERbefore = TIMER                     'count the elapsed time
        KEY(11) OFF: KEY(12) OFF: KEY(13) OFF: KEY(14) OFF': KEY(1) OFF: KEY(2) OFF
        ViewText 118, 100, "GAME OVER"
        PCOPY 0, 1
        DO: LOOP UNTIL TIMER > TIMERbefore + 1.5'minimum elapsed time
END SUB

SUB HaveLunch
        SELECT CASE map(INT((A + dinner((adda + 4) / 4, (addb + 4) / 4, 0)) / 16), INT((B + dinner((adda + 4) / 4, (addb + 4) / 4, 1)) / 16))
                CASE 3                          'red face
                IF (factor - 2) THEN
                        map(INT((A + dinner((adda + 4) / 4, (addb + 4) / 4, 0)) / 16), INT((B + dinner((adda + 4) / 4, (addb + 4) / 4, 1)) / 16)) = 0
                        flip = -1: factor = 2: accuracy = 6: character = 2
                        timeleft = badpactime
                        FOR i = 0 TO phantoms:
                                addgha(i) = -addgha(i): addghb(i) = -addghb(i)
                        NEXT i
                END IF
                CASE 4                          'food
                map(INT((A + dinner((adda + 4) / 4, (addb + 4) / 4, 0)) / 16), INT((B + dinner((adda + 4) / 4, (addb + 4) / 4, 1)) / 16)) = -7
                points = points + 8: foodleft = foodleft - 1
                CASE 5                          'right arrow
                IF (adda + 4) THEN
                        map(INT((A + dinner((adda + 4) / 4, (addb + 4) / 4, 0)) / 16), INT((B + dinner((adda + 4) / 4, (addb + 4) / 4, 1)) / 16)) = 0
                        points = points + 8: foodleft = foodleft - 1
                        dopath = 4: doadda = 4: doaddb = 0
                        ELSE A = Abefore: B = Bbefore
                END IF
                CASE 6                          'left arrow
                IF (adda - 4) THEN
                        map(INT((A + dinner((adda + 4) / 4, (addb + 4) / 4, 0)) / 16), INT((B + dinner((adda + 4) / 4, (addb + 4) / 4, 1)) / 16)) = 0
                        points = points + 8: foodleft = foodleft - 1
                        dopath = 4: doadda = -4: doaddb = 0
                        ELSE A = Abefore: B = Bbefore
                END IF
                CASE 7                          'down arrow
                IF (addb + 4) THEN
                        map(INT((A + dinner((adda + 4) / 4, (addb + 4) / 4, 0)) / 16), INT((B + dinner((adda + 4) / 4, (addb + 4) / 4, 1)) / 16)) = 0
                        points = points + 8: foodleft = foodleft - 1
                        dopath = 4: doadda = 0: doaddb = 4
                        ELSE A = Abefore: B = Bbefore
                END IF
                CASE 8                          'up arrow
                IF (addb - 4) THEN
                        map(INT((A + dinner((adda + 4) / 4, (addb + 4) / 4, 0)) / 16), INT((B + dinner((adda + 4) / 4, (addb + 4) / 4, 1)) / 16)) = 0
                        points = points + 8: foodleft = foodleft - 1
                        dopath = 4: doadda = 0: doaddb = -4
                        ELSE A = Abefore: B = Bbefore
                END IF
                CASE ELSE: EXIT SUB
        END SELECT
        'SOUND 600, .5: SOUND 400, .5
END SUB

SUB LoadMap (file$)
        'OPEN file$ FOR INPUT AS #2
                INPUT #2, stagename$, stagetext$
                INPUT #2, addlife, phantoms, bugs, badpactime
                FOR ydatabase = 0 TO 29
                        FOR xdatabase = 0 TO 33
                                INPUT #2, map(xdatabase, ydatabase)
                                SELECT CASE map(xdatabase, ydatabase)
                                        'L door
                                        CASE 98, -6
                                        CASE -5, 99
                                        'phantoms start over point
                                        CASE -8: aghost = xdatabase * 16 - 80: bghost = ydatabase * 16 - 80
                                        map(xdatabase, ydatabase) = 4: foodleft = foodleft + 1
                                        'pac variables initialization
                                        CASE IS < 0: A = xdatabase * 16 - 24: B = ydatabase * 16 - 24
                                        adda = pathsa(ABS(map(xdatabase, ydatabase)) - 1) * 4: addb = pathsb(ABS(map(xdatabase, ydatabase)) - 1) * 4
                                        'phantom variables initialization
                                        CASE 2: aghost = xdatabase * 16 - 80: bghost = ydatabase * 16 - 80
                                        'food counter
                                        CASE 4, 5, 6, 7, 8: foodleft = foodleft + 1
                                        'phantom prison door
                                        CASE 10: IF xdatabase > 0 AND xdatabase < 33 THEN xprison = xdatabase: yprison = ydatabase': prisons = prisons + 1
                                END SELECT
                        NEXT xdatabase
                NEXT ydatabase
        'CLOSE #2
        phantoms = phantoms - 1
END SUB

SUB LoadPcx (txt$)
        DIM H AS TH
        DIM dat AS STRING * 1
        OPEN txt$ FOR BINARY AS #1
        GET #1, 1, H
        C = 1
        Y = 0: X = 0
        WHILE C <= 64000
                GET #1, , dat
                IF ASC(dat) > 192 AND ASC(dat) <= 255 THEN
                        LPS = ASC(dat) - 192
                        GET #1, , dat
                        value = ASC(dat)
                        WHILE LPS > 0
                                PSET (X, Y), ega(value - 241)
                                IF X = 320 THEN X = 1: Y = Y + 1 ELSE X = X + 1
                                C = C + 1
                                LPS = LPS - 1
                        WEND
                ELSE
                        value = ASC(dat)
                        PSET (X, Y), value
                        IF X = 320 THEN X = 1: Y = Y + 1 ELSE X = X + 1
                        C = C + 1
                END IF
        WEND
        CLOSE #1
END SUB

SUB LoadRecords
        ViewText 105, 40, "HALL OF FAME"
        OPEN "records.txt" FOR INPUT AS #1
                WHILE NOT EOF(1)
                        INPUT #1, viewhallpoints, viewhallnames$
                        ViewText 86, 64 + insert, viewhallnames$ + STRING$(8 - LEN(STR$(viewhallpoints)), 46) + RIGHT$(STR$(viewhallpoints), LEN(STR$(viewhallpoints)) - 1)
                        insert = insert + 16
                WEND
        CLOSE #1
        ViewText 90, 164, "PRESS ANY KEY..."
        PCOPY 0, 1
        WHILE INKEY$ = "": WEND
END SUB

SUB MoveScreen
        'this version let you put so doors as you want. it is large but fast
        FOR xmap = INT(A / 16) - 3 TO 4 + 3 + INT(A / 16)
                SELECT CASE xmap
                        CASE IS > 32: remind = -32
                        CASE IS < 1: remind = 32
                        CASE ELSE: remind = 0
                END SELECT
                'rows 1 to 11
                FOR ymap = INT(B / 16) - 3 TO 4 + 3 + INT(B / 16)
                        SELECT CASE map(xmap + remind, ymap)
                                'prints the doors
                                CASE -109
                                IF ymap > INT(B / 16) - 3 THEN PUT (xmap * 16 - A + 128, (ymap - 1) * 16 - B + 70 + 2), door(0, 8)
                                PUT (xmap * 16 - A + 128, ymap * 16 - B + 70), door(0, 10), PSET
                                CASE -10
                                IF ymap > INT(B / 16) - 3 THEN PUT (xmap * 16 - A + 128, (ymap - 1) * 16 - B + 70 + 2), door(0, 9)
                                PUT (xmap * 16 - A + 128, ymap * 16 - B + 70), door(0, 11), PSET
                                CASE -5
                                IF ymap > INT(B / 16) - 3 THEN PUT (xmap * 16 - A + 136, (ymap - 1) * 16 - B + 70 + 2), door(0, 0)
                                PUT (xmap * 16 - A + 136, ymap * 16 - B + 70), door(0, 2), PSET
                                CASE 98
                                IF ymap > INT(B / 16) - 3 THEN PUT (xmap * 16 - A + 128, (ymap - 1) * 16 - B + 70 + 2), door(0, 1)
                                PUT (xmap * 16 - A + 128, ymap * 16 - B + 70), door(0, 3), PSET
                                CASE 99
                                IF ymap > INT(B / 16) - 3 THEN PUT (xmap * 16 - A + 128, (ymap - 1) * 16 - B + 70 + 2), door(0, 4)
                                PUT (xmap * 16 - A + 128, ymap * 16 - B + 70), door(0, 6), PSET
                                CASE -6
                                IF ymap > INT(B / 16) - 3 THEN PUT (xmap * 16 - A + 128, (ymap - 1) * 16 - B + 70 + 2), door(0, 5)
                                PUT (xmap * 16 - A + 128, ymap * 16 - B + 70), door(0, 7), PSET
                                'prints the rest of the objects
                                CASE IS > 2
                                PUT (xmap * 16 - A + 130, ymap * 16 - B + 70), tiles(0, map(xmap + remind, ymap))
                        END SELECT
                NEXT ymap
                'last row
                SELECT CASE map(xmap + remind, ymap)
                        'prints the upper door graphics
                        CASE -109
                        PUT (xmap * 16 - A + 128, (ymap - 1) * 16 - B + 70 + 2), door(0, 8)
                        CASE -10
                        PUT (xmap * 16 - A + 128, (ymap - 1) * 16 - B + 70 + 2), door(0, 9)
                        CASE -5
                        PUT (xmap * 16 - A + 136, (ymap - 1) * 16 - B + 70 + 2), door(0, 0)
                        CASE 98
                        PUT (xmap * 16 - A + 128, (ymap - 1) * 16 - B + 70 + 2), door(0, 1)
                        CASE 99
                        PUT (xmap * 16 - A + 128, (ymap - 1) * 16 - B + 70 + 2), door(0, 4)
                        CASE -6
                        PUT (xmap * 16 - A + 128, (ymap - 1) * 16 - B + 70 + 2), door(0, 5)
                END SELECT
        NEXT xmap
END SUB

SUB NextStage
        DIM TIMERbefore AS SINGLE
        TIMERbefore = TIMER                     'count the elapsed time
        KEY(11) OFF: KEY(12) OFF: KEY(13) OFF: KEY(14) OFF': KEY(1) OFF: KEY(2) OFF
        ViewText 90 + (128 - LEN(stagename$) * 8) / 2, 100, stagename$
        ViewText 90 + (128 - LEN(stagetext$) * 8) / 2, 120, stagetext$
        PALETTE 11, 0: PCOPY 0, 1
        DO: LOOP UNTIL TIMER > TIMERbefore + 1.5'minimum elapsed time
END SUB

SUB RandomMove
        ghostx = (ghosta(i) + 80) / 16
        ghosty = (ghostb(i) + 80) / 16
        IF map(ghostx - 1, ghosty) < 10 THEN moving = moving + 1
        IF map(ghostx + 1, ghosty) < 10 THEN moving = moving + 2
        IF map(ghostx, ghosty - 1) < 10 THEN moving = moving + 4
        IF map(ghostx, ghosty + 1) < 10 THEN moving = moving + 8
        SELECT CASE moving
                CASE 1
                addgha(i) = -1: addghb(i) = 0
                CASE 2
                addgha(i) = 1: addghb(i) = 0
                CASE 4
                addghb(i) = -1: addgha(i) = 0
                CASE 8
                addghb(i) = 1: addgha(i) = 0
                CASE 3
                which = INT(RND * 2)    'two random paths to choose
                addgha(i) = pathsb(which + 1): addghb(i) = 0
                CASE 5
                which = INT(RND * 2)    'two random paths to choose
                addgha(i) = pathsa(which): addghb(i) = pathsb(which)
                CASE 9
                which = INT(RND * 2)    'two random paths to choose
                addgha(i) = pathsa(which): addghb(i) = -pathsb(which)
                CASE 6
                which = INT(RND * 2)    'two random paths to choose
                addgha(i) = -pathsa(which): addghb(i) = pathsb(which)
                CASE 10
                which = INT(RND * 2)    'two random paths to choose
                addgha(i) = -pathsa(which): addghb(i) = -pathsb(which)
                CASE 12
                which = INT(RND * 2)    'two random paths to choose
                addgha(i) = 0: addghb(i) = pathsb(which + 1)
                CASE 7
                which = INT(RND * 3)    'three random paths to choose
                addgha(i) = pathsb(which): addghb(i) = pathsa(which)
                CASE 13
                which = INT(RND * 3)    'three random paths to choose
                addgha(i) = pathsa(which): addghb(i) = pathsb(which)
                CASE 11
                which = INT(RND * 3)    'three random paths to choose
                addgha(i) = pathsb(which): addghb(i) = -pathsa(which)
                CASE 14
                which = INT(RND * 3)    'three random paths to choose
                addgha(i) = -pathsa(which): addghb(i) = pathsb(which)
                CASE 15
                which = INT(RND * 4)    'four random paths to choose
                addgha(i) = pathsa(which): addghb(i) = pathsb(which)
                CASE ELSE
                addgha(i) = 0: addghb(i) = 0
        END SELECT
END SUB

SUB Ready
        KEY(11) OFF: KEY(12) OFF: KEY(13) OFF: KEY(14) OFF': KEY(1) OFF: KEY(2) OFF
        ViewText 114, 110, SPACE$(10)
        ViewText 114, 118, "  READY?  "
        ViewText 114, 126, SPACE$(10)
        PCOPY 0, 1
        DO: LOOP UNTIL INKEY$ = ""              'clears keyboard buffer
        WHILE INKEY$ = "": WEND
END SUB

SUB ViewPoints
        IF realpoints < points THEN realpoints = realpoints + 1
        lengthpoints = LEN(STR$(INT(realpoints)))
        FOR stepbystep = 2 TO lengthpoints
                PUT (228 + stepbystep * 8 - lengthpoints * 8, 188), font(0, VAL(MID$(STR$(INT(realpoints)), stepbystep, 1))), PSET
        NEXT stepbystep
        ViewText 80, 188, "&*" + RIGHT$(STR$(lives), LEN(STR$(lives)) - 1)
END SUB

SUB ViewText (X, Y, txt$)
        FOR stepbystep = 1 TO LEN(txt$)
                PUT (X + stepbystep * 8, Y), font(0, chrcodes(ASC(MID$(txt$, stepbystep, 1)))), PSET
        NEXT stepbystep
END SUB

SUB ViewWavyText (Y, txt$)
        VIEW SCREEN (0, Y - 35)-(319, Y + 35)
        FOR stepbystep = 1 TO LEN(txt$)
                C(stepbystep) = 169 + stepbystep * 6
        NEXT stepbystep
        WHILE INKEY$ = ""
                CLS
                FOR stepbystep = 1 TO LEN(txt$)
                        IF C(stepbystep) <= 169 THEN PSET (xx(C(stepbystep)), yy(C(stepbystep)) + Y), 0: DRAW "TA-" + STR$(angle(C(stepbystep))) + font$(chrcodes(ASC(MID$(txt$, stepbystep, 1))))
                        C(stepbystep) = C(stepbystep) - 1: IF C(stepbystep) < 0 THEN C(stepbystep) = LEN(txt$) * 6
                NEXT stepbystep
                PCOPY 0, 1
        WEND
END SUB

SUB ViewWindow (fromx, fromy, tox, toy)
        FOR Y = fromy TO toy
                FOR X = fromx TO tox
                        IF X = fromx AND Y = fromy THEN PUT (X * 8, Y * 8), boxes(0, 2), PSET: GOTO nextfor
                        IF X = tox AND Y = fromy THEN PUT (X * 8, Y * 8), boxes(0, 3), PSET: GOTO nextfor
                        IF X = fromx AND Y = toy THEN PUT (X * 8, Y * 8), boxes(0, 0), PSET: GOTO nextfor
                        IF X = tox AND Y = toy THEN PUT (X * 8, Y * 8), boxes(0, 1), PSET: GOTO nextfor
                        IF X = fromx THEN PUT (X * 8, Y * 8), boxes(0, 4), PSET: GOTO nextfor
                        IF X = tox THEN PUT (X * 8, Y * 8), boxes(0, 5), PSET: GOTO nextfor
                        IF Y = fromy THEN PUT (X * 8, Y * 8), boxes(0, 6), PSET: GOTO nextfor
                        IF Y = toy THEN PUT (X * 8, Y * 8), boxes(0, 7), PSET: GOTO nextfor
                        PUT (X * 8, Y * 8), boxes(0, 8), PSET
nextfor:
                NEXT X
        NEXT Y
END SUB

SUB Wall
        'FOR side = 0 TO 0 STEP 2
                SELECT CASE map(INT((A + corners((adda + 4) / 4, (addb + 4) / 4, 0 + side)) / 16), INT((B + corners((adda + 4) / 4, (addb + 4) / 4, 1 + side)) / 16))
                        CASE -5, -6
                        IF dooropening = 0 THEN
                                dopath = 11: doadda = adda: doaddb = 0: dooropening = 8 * ((adda + 4) / 4 - 1)
                                xopening = INT((A + corners((adda + 4) / 4, (addb + 4) / 4, 0 + side)) / 16) + (adda - 4) / 8
                                yopening = INT((B + corners((adda + 4) / 4, (addb + 4) / 4, 1 + side)) / 16)
                        END IF
                        CASE IS > 8
                        A = Abefore: B = Bbefore
                END SELECT
        'NEXT side
END SUB

